# Studio 5 Questions

# 1. Put your code answering the R questions in this file.
# 2. Before uploading the the code: clear your environment and source
#    the entire file (choose source from the code menu).
#   -- Make sure that it runs without error and outputs just the
#     answers asked for in the questions.
#   -- Remember to use print statements to print the values asked for
# 3. **** Upload your code to  ****
#    https://math.mit.edu/~dav/uploads

#-------------------------
# Setup
# Five types of dice: 4, 6, 8, 12, 20 sided.
# There is a prior distribution of the quantity of each die.
# One die is chosen at random and rolled repeatedly.
# Our job is to figure out which type of die was chosen.

#-------------------------------
# Problem 0.
# (a) List all possible hypotheses. (Use print())

# (b) List all possible outcomes for the jth roll. (Use print())

# (c) Print the entire likelihood table for a single roll.
# Your table should have a column of likelihoods for each possible outcome.

#---------------------------
# Problem 1
# (1a) Go through Example 2 from studio5.r.

# (1b) The data from that example is saved in the variable called 'dataRolls'. Use the same data and redo the Bayesian updating using the prior distribution given below.
### DO NOT regenerate the choice of random die or the
### data. For this problem the prior is only here to start the Bayesian updating.
# You can comment out or delete the intermediate printing and bar plots, but be sure to make the stacked bar plot at the end.

prior=c(.001,.001,.001,.001,.996)  ## NEW PRIOR

# ********* YOUR CODE HERE ***********

# (1c)
# Describe how the posterior distributions in (a) and (b) compare.

# (1d) Redo the simulation, but instead of randomly choosing the die, set it to the 20-sided die.
# Use the prior, nrolls and seed given below
# You can comment out or delete the intermediate printing and bar plots, but be sure to make the stacked bar plot at the end.
nrolls=20  #roll the die nrolls times
prior=c(.2,.2,.2,.2,.2)
set.seed(1)

# ******** YOUR CODE HERE **********

#---------------------------
# Problem 2. Censored data
# Suppose we can only get 'censored data'. That is, instead of seeing the result of each roll we are given a 1 if the roll is a 1 and a 0 for any other outcome. Our goal is still to find out which die was chosen.

# (2a) (i) List all possible hypotheses.
# (ii) Write out the full likelihood table.

# (2b) Modify the R simulation to simulate this censored scenario.
# You can comment out or delete the intermediate printing and bar plots, but be sure to make the stacked bar plot at the end.
# Use the prior, nrolls and seed given below
nrolls = 20
prior = c(.2,.2,.2,.2,.2)
set.seed(1)

# ******** YOUR CODE HERE **********

# (2c) Investigate how many rolls it takes to see a clear convergence of the posterior distribution
# You can comment out or delete the intermediate printing and bar plots, but be sure to make the stacked bar plot at the end.

# Redo with nrolls = 200
nrolls=200
prior=c(.2,.2,.2,.2,.2)
set.seed(1)

# ******** YOUR CODE HERE **********

# Redo with nrolls = 2000
# We recommend commenting out the part of the code that prints the tables and draws each of the bar plots.
# Only draw the stacked bar plot at the end.
# Note: some monitors don't have enough resolution and
# the stacked bar plot will be all black.
nrolls=2000
prior=c(.2,.2,.2,.2,.2)
set.seed(1)

# ******** YOUR CODE HERE **********

#----------------------------------------------------
# **** Upload your code to  ****
#    https://math.mit.edu/~dav/uploads
#
#-----------------------------------------------------
